package imap

import (
	cnsm "git.loafle.net/commons_go/network_service_matcher"
)

const (
	PRE_COMPARE_STR  = "* OK"
	SEND_COMPARE_STR = "* BYE"
)

type IMAPMatcher struct {
	cnsm.Matchers
}

func (i *IMAPMatcher) ServiceName() string {
	return "IMAP"
}

func (i *IMAPMatcher) IsPrePacket() bool {
	return true
}

func (i *IMAPMatcher) HasResponse(index int) bool {
	return true
}

func (i *IMAPMatcher) IsError(info cnsm.MatchInfo, index int, packet *cnsm.Packet) bool {
	return false
}

func (i *IMAPMatcher) Match(info cnsm.MatchInfo, index int, packet *cnsm.Packet) bool {

	switch index {
	case 0:

		recvStr := string(packet.Buffer)

		if len(recvStr) < 3 {
			return false
		}

		compareStr := recvStr[0:4]

		if compareStr == PRE_COMPARE_STR {
			return true
		}

	case 1:

		recvStr := string(packet.Buffer)

		if len(recvStr) < 5 {
			return false
		}

		compareStr := recvStr[0:5]

		if compareStr == SEND_COMPARE_STR {
			return true
		}

	}

	return false
}

func NewMatcher() cnsm.Matcher {

	m := &IMAPMatcher{}

	reqStr := "A0001 LOGOUT\r\n"
	byte := make([]byte, len(reqStr))
	copy(byte[:], reqStr)

	m.AddPacket(cnsm.NewPacket(byte, len(reqStr)))

	return m

}
