package smb

import (
	"net"
	"testing"

	cnsm "git.loafle.net/commons_go/network_service_matcher"
)

const (
	ADDR string = "192.168.1.106:445"
)

func TestSMBMatcher(t *testing.T) {

	m := NewMatcher()

	conn, err := net.Dial("tcp", ADDR)

	if err != nil {
		t.Fatal(err)
	}

	defer conn.Close()

	for i := 0; i < m.PacketCount(); i++ {

		pack := m.Packet(i)
		conn.Write(pack.Buffer)
		bytes := make([]byte, 1024)
		n, _ := conn.Read(bytes)

		p := cnsm.NewPacket(bytes, n)

		if m.Match(nil, i, p) {
			t.Log("SMB found.")
			return
		}

		t.Error("SMB not found")
	}

}
